diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockFarmland.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicFarmland.java
similarity index 82%
rename from game/core/src/main/java/net/minecraft/core/block/BlockFarmland.java
rename to game/core/src/main/java/net/minecraft/core/block/BlockLogicFarmland.java
index baf6712e1..c7e699f21 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockFarmland.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicFarmland.java
@@ -18,16 +18,16 @@ import org.jetbrains.annotations.Nullable;
 
 import java.util.Random;
 
-public class BlockFarmland extends Block implements IBonemealable
+public class BlockLogicFarmland extends BlockLogic implements IBonemealable
 {
 	public static final int MASK_FERTILIZED = 0b0001_0000;
 	public static final int MASK_WET = 0b0000_1111;
-	public BlockFarmland(String key, String namespaceId, int id)
+	public BlockLogicFarmland(Block<?> block)
 	{
-		super(key, namespaceId, id, Material.dirt);
+		super(block, Material.dirt);
 		setBlockBounds(0.0F, 0.0F, 0.0F, 1.0F, 0.9375F, 1.0F);
-		withLightBlock(255);
-		setTicking(true);
+		block.withLightBlock(255);
+		block.setTicking(true);
 	}
 
 	public static boolean isWet(int data) {
@@ -101,7 +101,7 @@ public class BlockFarmland extends Block implements IBonemealable
 		{
 			for (int iz = z - radius; iz <= z + radius; iz++)
 			{
-				if (world.getBlockId(ix, y + 1, iz) == Blocks.CROPS_WHEAT.id)
+				if (world.getBlockId(ix, y + 1, iz) == Blocks.CROPS_WHEAT.id())
 				{
 					return true;
 				}
@@ -126,7 +126,7 @@ public class BlockFarmland extends Block implements IBonemealable
 			{
 				for (int z1 = z - range; z1 <= z + range; z1++)
 				{
-					if (Block.hasTag(world.getBlockId(x1, y1, z1), BlockTags.IS_WATER))
+					if (Blocks.hasTag(world.getBlockId(x1, y1, z1), BlockTags.IS_WATER))
 					{
 						return true;
 					}
@@ -149,9 +149,9 @@ public class BlockFarmland extends Block implements IBonemealable
 					return;
 				}
 				if(isWet(world.getBlockMetadata(x, y, z)))
-					world.setBlockWithNotify(x, y, z, Blocks.MUD.id);
+					world.setBlockWithNotify(x, y, z, Blocks.MUD.id());
 				else
-					world.setBlockWithNotify(x, y, z, Blocks.DIRT.id);
+					world.setBlockWithNotify(x, y, z, Blocks.DIRT.id());
 
 			}
 		}
@@ -160,7 +160,7 @@ public class BlockFarmland extends Block implements IBonemealable
 	@Override
 	public void onBlockPlacedByWorld(World world, int x, int y, int z)
 	{
-		world.scheduleBlockUpdate(x, y, z, id, tickDelay() - world.rand.nextInt(10) + world.rand.nextInt(10));
+		world.scheduleBlockUpdate(x, y, z, block.id(), tickDelay() - world.rand.nextInt(10) + world.rand.nextInt(10));
 	}
 
 	@Override
@@ -171,12 +171,12 @@ public class BlockFarmland extends Block implements IBonemealable
 		if (material.isSolid() && material != Material.vegetable)
 		{
 			if(isWet(world.getBlockMetadata(x, y, z)))
-				world.setBlockWithNotify(x, y, z, Blocks.MUD.id);
+				world.setBlockWithNotify(x, y, z, Blocks.MUD.id());
 			else
-				world.setBlockWithNotify(x, y, z, Blocks.DIRT.id);
+				world.setBlockWithNotify(x, y, z, Blocks.DIRT.id());
 
 		} else {
-			world.scheduleBlockUpdate(x, y, z, id, tickDelay() - world.rand.nextInt(10) + world.rand.nextInt(10));
+			world.scheduleBlockUpdate(x, y, z, block.id(), tickDelay() - world.rand.nextInt(10) + world.rand.nextInt(10));
 		}
 	}
 
@@ -196,7 +196,7 @@ public class BlockFarmland extends Block implements IBonemealable
 					{
 						//...And the block is next to another wet mud block, it can become wet
 						int bID = world.getBlockId(x1, y1, z1);
-						if (bID == Blocks.MUD.id || (bID == Blocks.FARMLAND_DIRT.id && BlockFarmland.isWet(world.getBlockMetadata(x1, y1, z1))))
+						if (bID == Blocks.MUD.id() || (bID == Blocks.FARMLAND_DIRT.id() && BlockLogicFarmland.isWet(world.getBlockMetadata(x1, y1, z1))))
 						{
 							return true;
 						}
@@ -217,7 +217,7 @@ public class BlockFarmland extends Block implements IBonemealable
 	@Override
 	public void updateTick(final World world, final int x, final int y, final int z, final Random rand) {
 		if (rand.nextInt(2) != 0) {
-			world.scheduleBlockUpdate(x, y, z, id, tickDelay() - rand.nextInt(10) + rand.nextInt(10));
+			world.scheduleBlockUpdate(x, y, z, block.id(), tickDelay() - rand.nextInt(10) + rand.nextInt(10));
 			return;
 		}
 		int data = world.getBlockMetadata(x, y, z);
@@ -225,14 +225,14 @@ public class BlockFarmland extends Block implements IBonemealable
 		if (isWaterNearby(world, x, y, z, 4) || world.canBlockBeRainedOn(x, y + 1, z)) {
 			if (hydration < 15 && canBecomeWet(world, x, y, z)) {
 				world.setBlockMetadataWithNotify(x, y, z, setWet(data, hydration + 1));
-				world.scheduleBlockUpdate(x, y, z, id, tickDelay() - rand.nextInt(10) + rand.nextInt(10));
+				world.scheduleBlockUpdate(x, y, z, block.id(), tickDelay() - rand.nextInt(10) + rand.nextInt(10));
 			}
 		} else {
 			if (hydration > 0) {
 				world.setBlockMetadataWithNotify(x, y, z, setWet(data, hydration - 1));
-				world.scheduleBlockUpdate(x, y, z, id, tickDelay() - rand.nextInt(10) + rand.nextInt(10));
+				world.scheduleBlockUpdate(x, y, z, block.id(), tickDelay() - rand.nextInt(10) + rand.nextInt(10));
 			} else if (!isCropsNearby(world, x, y, z)) {
-				world.setBlockWithNotify(x, y, z, Blocks.DIRT.id);
+				world.setBlockWithNotify(x, y, z, Blocks.DIRT.id());
 			}
 		}
 	}
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockFence.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicFence.java
similarity index 89%
rename from game/core/src/main/java/net/minecraft/core/block/BlockFence.java
rename to game/core/src/main/java/net/minecraft/core/block/BlockLogicFence.java
index a57893b55..b7423fbfc 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockFence.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicFence.java
@@ -7,7 +7,7 @@ import net.minecraft.core.block.tag.BlockTags;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.WorldSource;
 
-public class BlockFence extends Block implements IPaintable
+public class BlockLogicFence extends BlockLogic implements IPaintable
 {
 //    private static final List<BoundingVolume> selectionVolumes = new ArrayList<>();
 //
@@ -53,9 +53,9 @@ public class BlockFence extends Block implements IPaintable
 //        selectionVolumes.add(newVolume);
 //    }
 
-    public BlockFence(String key, String namespaceId, int id)
+    public BlockLogicFence(Block<?> block)
     {
-        super(key, namespaceId, id, Material.wood);
+        super(block, Material.wood);
     }
 
     @Override
@@ -110,15 +110,15 @@ public class BlockFence extends Block implements IPaintable
         return false;
     }
 
-    public boolean canConnectTo(WorldSource iblockaccess, int x, int y, int z)
+    public boolean canConnectTo(WorldSource worldSource, int x, int y, int z)
     {
-        int l = iblockaccess.getBlockId(x, y, z);
-        return Block.hasTag(l, BlockTags.FENCES_CONNECT);
+        int l = worldSource.getBlockId(x, y, z);
+        return Blocks.hasTag(l, BlockTags.FENCES_CONNECT);
     }
 
     @Override
     public void setColor(World world, int x, int y, int z, DyeColor color) {
-        world.setBlock(x, y, z, Blocks.FENCE_PLANKS_OAK_PAINTED.id);
-        ((IPaintable) Blocks.FENCE_PLANKS_OAK_PAINTED).setColor(world, x, y, z, color);
+        world.setBlock(x, y, z, Blocks.FENCE_PLANKS_OAK_PAINTED.id());
+        Blocks.FENCE_PLANKS_OAK_PAINTED.getLogic().setColor(world, x, y, z, color);
     }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockFenceChainlink.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicFenceChainlink.java
similarity index 50%
rename from game/core/src/main/java/net/minecraft/core/block/BlockFenceChainlink.java
rename to game/core/src/main/java/net/minecraft/core/block/BlockLogicFenceChainlink.java
index 82ccb045a..49f58ab89 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockFenceChainlink.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicFenceChainlink.java
@@ -5,18 +5,18 @@ import net.minecraft.core.block.tag.BlockTags;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.WorldSource;
 
-public class BlockFenceChainlink extends BlockFenceThin
+public class BlockLogicFenceChainlink extends BlockLogicFenceThin
 {
-    public BlockFenceChainlink(String key, String namespaceId, int id, Material material)
+    public BlockLogicFenceChainlink(Block<?> block, Material material)
     {
-        super(key, namespaceId, id, material);
+        super(block, material);
     }
 
     @Override
     public boolean canConnectTo(WorldSource world, int x, int y, int z)
     {
-        int id = world.getBlockId(x, y, z);
-        return Block.hasTag(id, BlockTags.CHAINLINK_FENCES_CONNECT) || (Blocks.blocksList[id] != null && (Blocks.blocksList[id].blockMaterial.isStone() || Blocks.blocksList[id].blockMaterial.isMetal()));
+        Block<?> b = world.getBlock(x, y, z);
+        return BlockTags.CHAINLINK_FENCES_CONNECT.appliesTo(b) || (b != null && (b.getMaterial().isStone() || b.getMaterial().isMetal()));
     }
     
     @Override
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockFenceGate.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicFenceGate.java
similarity index 93%
rename from game/core/src/main/java/net/minecraft/core/block/BlockFenceGate.java
rename to game/core/src/main/java/net/minecraft/core/block/BlockLogicFenceGate.java
index 75b791a04..4812453c2 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockFenceGate.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicFenceGate.java
@@ -17,14 +17,14 @@ import net.minecraft.core.world.WorldSource;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 
-public class BlockFenceGate extends Block implements IPaintable
+public class BlockLogicFenceGate extends BlockLogic implements IPaintable
 {
     public static final int MASK_DIRECTION = 0b0000_0011;
     public static final int MASK_OPEN = 0b0000_0100;
 
-    public BlockFenceGate(String key, String namespaceId, int id)
+    public BlockLogicFenceGate(Block<?> block)
     {
-        super(key, namespaceId, id, Material.wood);
+        super(block, Material.wood);
     }
 
     @Override
@@ -142,7 +142,7 @@ public class BlockFenceGate extends Block implements IPaintable
     @Override
     public void setColor(World world, int x, int y, int z, DyeColor color) {
         final int meta = world.getBlockMetadata(x, y, z);
-        world.setBlockAndMetadata(x, y, z, Blocks.FENCE_GATE_PLANKS_OAK_PAINTED.id, meta);
-        ((IPaintable) Blocks.FENCE_GATE_PLANKS_OAK_PAINTED).setColor(world, x, y, z, color);
+        world.setBlockAndMetadata(x, y, z, Blocks.FENCE_GATE_PLANKS_OAK_PAINTED.id(), meta);
+        Blocks.FENCE_GATE_PLANKS_OAK_PAINTED.getLogic().setColor(world, x, y, z, color);
     }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockFenceGatePainted.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicFenceGatePainted.java
similarity index 87%
rename from game/core/src/main/java/net/minecraft/core/block/BlockFenceGatePainted.java
rename to game/core/src/main/java/net/minecraft/core/block/BlockLogicFenceGatePainted.java
index ec37c65b9..90bd3a410 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockFenceGatePainted.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicFenceGatePainted.java
@@ -9,12 +9,12 @@ import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.World;
 import org.jetbrains.annotations.Nullable;
 
-public class BlockFenceGatePainted extends BlockFenceGate implements IPainted
+public class BlockLogicFenceGatePainted extends BlockLogicFenceGate implements IPainted
 {
 	public static final int MASK_COLOR = 0b1111_0000;
-	public BlockFenceGatePainted(String key, String namespaceId, int id)
+	public BlockLogicFenceGatePainted(Block<?> block)
 	{
-		super(key, namespaceId, id);
+		super(block);
 	}
 	
 	@Override
@@ -46,7 +46,7 @@ public class BlockFenceGatePainted extends BlockFenceGate implements IPainted
 	@Override
 	public void removeDye(World world, int x, int y, int z) {
 		final int meta = world.getBlockMetadata(x, y, z);
-		world.setBlockAndMetadataWithNotify(x, y, z, Blocks.FENCE_GATE_PLANKS_OAK.id, meta & ~MASK_COLOR);
+		world.setBlockAndMetadataWithNotify(x, y, z, Blocks.FENCE_GATE_PLANKS_OAK.id(), meta & ~MASK_COLOR);
 	}
 
 	@Override
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockFencePainted.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicFencePainted.java
similarity index 84%
rename from game/core/src/main/java/net/minecraft/core/block/BlockFencePainted.java
rename to game/core/src/main/java/net/minecraft/core/block/BlockLogicFencePainted.java
index 8bb402d15..929bc64b8 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockFencePainted.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicFencePainted.java
@@ -9,11 +9,11 @@ import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.World;
 import org.jetbrains.annotations.Nullable;
 
-public class BlockFencePainted extends BlockFence implements IPainted
+public class BlockLogicFencePainted extends BlockLogicFence implements IPainted
 {
-	public BlockFencePainted(String key, String namespaceId, int id)
+	public BlockLogicFencePainted(Block<?> block)
 	{
-		super(key, namespaceId, id);
+		super(block);
 	}
 	
 	@Override
@@ -44,7 +44,7 @@ public class BlockFencePainted extends BlockFence implements IPainted
 
 	@Override
 	public void removeDye(World world, int x, int y, int z) {
-		world.setBlockWithNotify(x, y, z, Blocks.FENCE_PLANKS_OAK.id);
+		world.setBlockWithNotify(x, y, z, Blocks.FENCE_PLANKS_OAK.id());
 	}
 
 	@Override
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicFenceSteel.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicFenceSteel.java
new file mode 100644
index 000000000..1b3f4f2fd
--- /dev/null
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicFenceSteel.java
@@ -0,0 +1,17 @@
+package net.minecraft.core.block;
+
+import net.minecraft.core.block.material.Material;
+import net.minecraft.core.block.tag.BlockTags;
+import net.minecraft.core.world.WorldSource;
+
+public class BlockLogicFenceSteel extends BlockLogicFenceThin {
+    public BlockLogicFenceSteel(Block<?> block, Material material) {
+        super(block, material);
+    }
+
+    @Override
+    public boolean canConnectTo(WorldSource world, int x, int y, int z) {
+        Block<?> block = world.getBlock(x, y, z);
+        return BlockTags.CHAINLINK_FENCES_CONNECT.appliesTo(block) || (block != null && (block.getMaterial().isStone() || block.getMaterial().isMetal()));
+    }
+}
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockFenceThin.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicFenceThin.java
similarity index 89%
rename from game/core/src/main/java/net/minecraft/core/block/BlockFenceThin.java
rename to game/core/src/main/java/net/minecraft/core/block/BlockLogicFenceThin.java
index 3cb49d597..7306274d1 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockFenceThin.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicFenceThin.java
@@ -5,11 +5,11 @@ import net.minecraft.core.util.helper.Direction;
 import net.minecraft.core.util.phys.AABB;
 import net.minecraft.core.world.WorldSource;
 
-public abstract class BlockFenceThin extends Block
+public abstract class BlockLogicFenceThin extends BlockLogic
 {
-    public BlockFenceThin(String key, String namespaceId, int id, Material material)
+    public BlockLogicFenceThin(Block<?> block, Material material)
     {
-        super(key, namespaceId, id, material);
+        super(block, material);
     }
 
     @Override
@@ -47,14 +47,14 @@ public abstract class BlockFenceThin extends Block
         if (drawColumn) return true;
 
         int oy = 1;
-        while (world.getBlockId(x, y + oy, z) == this.id)
+        while (world.getBlockId(x, y + oy, z) == block.id())
         {
             oy++;
         }
         oy--;
 
         boolean drawColumnFromOther = false;
-        while (world.getBlockId(x, y + oy, z) == this.id)
+        while (world.getBlockId(x, y + oy, z) == block.id())
         {
             if (shouldDrawColumn_do(world, x, y + oy, z))
             {
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockFenceWallPaper.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicFenceWallPaper.java
similarity index 57%
rename from game/core/src/main/java/net/minecraft/core/block/BlockFenceWallPaper.java
rename to game/core/src/main/java/net/minecraft/core/block/BlockLogicFenceWallPaper.java
index d8b13eab3..a8fa39226 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockFenceWallPaper.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicFenceWallPaper.java
@@ -4,17 +4,17 @@ import net.minecraft.core.block.material.Material;
 import net.minecraft.core.block.tag.BlockTags;
 import net.minecraft.core.world.WorldSource;
 
-public class BlockFenceWallPaper extends BlockFenceThin
+public class BlockLogicFenceWallPaper extends BlockLogicFenceThin
 {
-    public BlockFenceWallPaper(String key, String namespaceId, int id, Material material)
+    public BlockLogicFenceWallPaper(Block<?> block, Material material)
     {
-        super(key, namespaceId, id, material);
+        super(block, material);
     }
 
     @Override
     public boolean canConnectTo(WorldSource world, int x, int y, int z)
     {
         int l = world.getBlockId(x, y, z);
-        return Block.hasTag(l, BlockTags.FENCES_CONNECT);
+        return Blocks.hasTag(l, BlockTags.FENCES_CONNECT);
     }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockFire.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicFire.java
similarity index 78%
rename from game/core/src/main/java/net/minecraft/core/block/BlockFire.java
rename to game/core/src/main/java/net/minecraft/core/block/BlockLogicFire.java
index 9158324f7..03e988a02 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockFire.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicFire.java
@@ -13,7 +13,7 @@ import net.minecraft.core.world.World;
 
 import java.util.Random;
 
-public class BlockFire extends Block {
+public class BlockLogicFire extends BlockLogic {
 	public static final int FLAME_INSTANT = 60;
 	public static final int FLAME_EASY = 30;
 	public static final int FLAME_MEDIUM = 15;
@@ -26,9 +26,9 @@ public class BlockFire extends Block {
 	private static final int[] flameChance = new int[Blocks.blocksList.length];
 	private static final int[] burnChance = new int[Blocks.blocksList.length];
 
-	public BlockFire(String key, String namespaceId, int id) {
-		super(key, namespaceId, id, Material.fire);
-		setTicking(true);
+	public BlockLogicFire(Block<?> block) {
+		super(block, Material.fire);
+		block.setTicking(true);
 		setBlockBounds(0.0f, 0.0f, 0.0f, 1.0f, 1.0f, 1.0f);
 	}
 
@@ -40,40 +40,40 @@ public class BlockFire extends Block {
 
 	@Override
 	public void initializeBlock() {
-		setFlammable(Blocks.PLANKS_OAK.id, FLAME_HARD, BURN_MEDIUM);
-		setFlammable(Blocks.PLANKS_OAK_PAINTED.id, FLAME_HARD, BURN_MEDIUM);
-		setFlammable(Blocks.FENCE_PLANKS_OAK.id, FLAME_HARD, BURN_MEDIUM);
-		setFlammable(Blocks.FENCE_PLANKS_OAK_PAINTED.id, FLAME_HARD, BURN_MEDIUM);
-		setFlammable(Blocks.SLAB_PLANKS_OAK.id, FLAME_HARD, BURN_MEDIUM);
-		setFlammable(Blocks.SLAB_PLANKS_PAINTED.id, FLAME_HARD, BURN_MEDIUM);
-		setFlammable(Blocks.STAIRS_PLANKS_OAK.id, FLAME_HARD, BURN_MEDIUM);
-		setFlammable(Blocks.LOG_OAK.id, FLAME_HARD, BURN_HARD);
-		setFlammable(Blocks.LOG_PINE.id, FLAME_HARD, BURN_HARD);
-		setFlammable(Blocks.LOG_BIRCH.id, FLAME_HARD, BURN_HARD);
-		setFlammable(Blocks.LOG_CHERRY.id, FLAME_HARD, BURN_HARD);
-		setFlammable(Blocks.LOG_OAK_MOSSY.id, FLAME_HARD, BURN_HARD);
-		setFlammable(Blocks.LOG_EUCALYPTUS.id, FLAME_HARD, BURN_HARD);
-		setFlammable(Blocks.LEAVES_OAK.id, FLAME_EASY, BURN_EASY);
-		setFlammable(Blocks.LEAVES_PINE.id, FLAME_EASY, BURN_EASY);
-		setFlammable(Blocks.LEAVES_BIRCH.id, FLAME_EASY, BURN_EASY);
-		setFlammable(Blocks.LEAVES_CHERRY.id, FLAME_EASY, BURN_EASY);
-		setFlammable(Blocks.LEAVES_CHERRY_FLOWERING.id, FLAME_EASY, BURN_EASY);
-		setFlammable(Blocks.LEAVES_OAK_RETRO.id, FLAME_EASY, BURN_EASY);
-		setFlammable(Blocks.LEAVES_SHRUB.id, FLAME_EASY, BURN_EASY);
-		setFlammable(Blocks.LEAVES_EUCALYPTUS.id, FLAME_EASY, BURN_EASY);
-		setFlammable(Blocks.LEAVES_CACAO.id, FLAME_EASY, BURN_EASY);
-		setFlammable(Blocks.BOOKSHELF_PLANKS_OAK.id, FLAME_EASY, BURN_MEDIUM);
-		setFlammable(Blocks.TNT.id, FLAME_MEDIUM, BURN_INSTANT);
-		setFlammable(Blocks.WOOL.id, FLAME_EASY, BURN_EASY);
-		setFlammable(Blocks.MOSS_STONE.id, 100, 30);
-		setFlammable(Blocks.MOSS_BASALT.id, 100, 30);
-		setFlammable(Blocks.MOSS_LIMESTONE.id, 100, 30);
-		setFlammable(Blocks.MOSS_GRANITE.id, 100, 30);
+		setFlammable(Blocks.PLANKS_OAK, FLAME_HARD, BURN_MEDIUM);
+		setFlammable(Blocks.PLANKS_OAK_PAINTED, FLAME_HARD, BURN_MEDIUM);
+		setFlammable(Blocks.FENCE_PLANKS_OAK, FLAME_HARD, BURN_MEDIUM);
+		setFlammable(Blocks.FENCE_PLANKS_OAK_PAINTED, FLAME_HARD, BURN_MEDIUM);
+		setFlammable(Blocks.SLAB_PLANKS_OAK, FLAME_HARD, BURN_MEDIUM);
+		setFlammable(Blocks.SLAB_PLANKS_PAINTED, FLAME_HARD, BURN_MEDIUM);
+		setFlammable(Blocks.STAIRS_PLANKS_OAK, FLAME_HARD, BURN_MEDIUM);
+		setFlammable(Blocks.LOG_OAK, FLAME_HARD, BURN_HARD);
+		setFlammable(Blocks.LOG_PINE, FLAME_HARD, BURN_HARD);
+		setFlammable(Blocks.LOG_BIRCH, FLAME_HARD, BURN_HARD);
+		setFlammable(Blocks.LOG_CHERRY, FLAME_HARD, BURN_HARD);
+		setFlammable(Blocks.LOG_OAK_MOSSY, FLAME_HARD, BURN_HARD);
+		setFlammable(Blocks.LOG_EUCALYPTUS, FLAME_HARD, BURN_HARD);
+		setFlammable(Blocks.LEAVES_OAK, FLAME_EASY, BURN_EASY);
+		setFlammable(Blocks.LEAVES_PINE, FLAME_EASY, BURN_EASY);
+		setFlammable(Blocks.LEAVES_BIRCH, FLAME_EASY, BURN_EASY);
+		setFlammable(Blocks.LEAVES_CHERRY, FLAME_EASY, BURN_EASY);
+		setFlammable(Blocks.LEAVES_CHERRY_FLOWERING, FLAME_EASY, BURN_EASY);
+		setFlammable(Blocks.LEAVES_OAK_RETRO, FLAME_EASY, BURN_EASY);
+		setFlammable(Blocks.LEAVES_SHRUB, FLAME_EASY, BURN_EASY);
+		setFlammable(Blocks.LEAVES_EUCALYPTUS, FLAME_EASY, BURN_EASY);
+		setFlammable(Blocks.LEAVES_CACAO, FLAME_EASY, BURN_EASY);
+		setFlammable(Blocks.BOOKSHELF_PLANKS_OAK, FLAME_EASY, BURN_MEDIUM);
+		setFlammable(Blocks.TNT, FLAME_MEDIUM, BURN_INSTANT);
+		setFlammable(Blocks.WOOL, FLAME_EASY, BURN_EASY);
+		setFlammable(Blocks.MOSS_STONE, 100, 30);
+		setFlammable(Blocks.MOSS_BASALT, 100, 30);
+		setFlammable(Blocks.MOSS_LIMESTONE, 100, 30);
+		setFlammable(Blocks.MOSS_GRANITE, 100, 30);
 	}
 
-	public static void setFlammable(int id, int flameChance, int burnChance) {
-		BlockFire.flameChance[id] = flameChance;
-		BlockFire.burnChance[id] = burnChance;
+	public static void setFlammable(Block<?> block, int flameChance, int burnChance) {
+		BlockLogicFire.flameChance[block.id()] = flameChance;
+		BlockLogicFire.burnChance[block.id()] = burnChance;
 	}
 
 	@Override
@@ -111,7 +111,7 @@ public class BlockFire extends Block {
 
 	@Override
 	public void updateTick(World world, int x, int y, int z, Random rand) {
-		Block blockUnder = world.getBlock(x, y - 1, z);
+		Block<?> blockUnder = world.getBlock(x, y - 1, z);
 		boolean infiniBurn = blockUnder != null && blockUnder.hasTag(BlockTags.INFINITE_BURN) || !world.getGameRuleValue(GameRules.DO_FIRE_SPREAD);
 
 		//Extinguish fire
@@ -134,7 +134,7 @@ public class BlockFire extends Block {
 		if (meta < 15) {
 			world.setBlockMetadata(x, y, z, meta + rand.nextInt(3) / 2);
 		}
-		world.scheduleBlockUpdate(x, y, z, id, tickDelay());
+		world.scheduleBlockUpdate(x, y, z, block.id(), tickDelay());
 		
 		
 		if (!infiniBurn && !canNeighborCatchFire(world, x, y, z)) {
@@ -185,7 +185,7 @@ public class BlockFire extends Block {
 					
 					if(world.getGameRuleValue(GameRules.DO_FIRE_SPREAD) && getBurnResultId(world, x1, y1, z1) == 0 /* Fix for fire destroying moss blocks */) {
 						//Spread Fire with higher meta
-						world.setBlockAndMetadataWithNotify(x1, y1, z1, id, Math.min(meta + rand.nextInt(5) / 4, 15));
+						world.setBlockAndMetadataWithNotify(x1, y1, z1, block.id(), Math.min(meta + rand.nextInt(5) / 4, 15));
 					}
 				}
 
@@ -198,20 +198,19 @@ public class BlockFire extends Block {
 	private void checkBurn(World world, int x, int y, int z, int chance, Random random, int meta) {
 		if (!world.getGameRuleValue(GameRules.DO_FIRE_SPREAD)) return;
 		if (random.nextInt(chance) < burnChance[world.getBlockId(x, y, z)]) {
-			boolean isTNT = world.getBlockId(x, y, z) == Blocks.TNT.id;
+			boolean isTNT = world.getBlockId(x, y, z) == Blocks.TNT.id();
 			
 			if (random.nextInt(meta + 10) < 5 && !world.canBlockBeRainedOn(x, y, z)) {
 				if(getBurnResultId(world, x, y, z) == 0 /* Fix for fire destroying moss blocks */) {
 					//Spread Fire with higher meta
-					world.setBlockAndMetadataWithNotify(x, y, z, id, Math.min(meta + random.nextInt(5) / 4, 15));
+					world.setBlockAndMetadataWithNotify(x, y, z, block.id(), Math.min(meta + random.nextInt(5) / 4, 15));
 				}
 			} else {
 				setBurnResult(world, x, y, z);
 			}
 			
 			if (isTNT) {
-				BlockTNT TNTBlock = (BlockTNT) Blocks.TNT;
-				TNTBlock.ignite(world, x, y, z, true);
+				Blocks.TNT.getLogic().ignite(world, x, y, z, true);
 			}
 		}
 	}
@@ -271,23 +270,22 @@ public class BlockFire extends Block {
 
 	protected int getBurnResultId(World world, int x, int y, int z) {
 		int id = world.getBlockId(x, y, z);
-		Block stoneBlock = BlockMoss.getStoneBlock(id);
+		Block<?> stoneBlock = BlockLogicMoss.getStoneBlock(id);
 		if (stoneBlock != null) {
-			return stoneBlock.id;
+			return stoneBlock.id();
 		}
 		return 0;
 	}
 
 	@Override
 	public void onBlockPlacedByWorld(World world, int x, int y, int z) {
-		if (world.getBlockId(x, y - 1, z) == Blocks.OBSIDIAN.id
-				&& ((BlockPortal) Blocks.PORTAL_NETHER).tryToCreatePortal(world, x, y, z, null)) {
+		if (world.getBlockId(x, y - 1, z) == Blocks.OBSIDIAN.id() && Blocks.PORTAL_NETHER.getLogic().tryToCreatePortal(world, x, y, z, null)) {
 			return;
 		}
 		if (!world.isBlockNormalCube(x, y - 1, z) && !canNeighborCatchFire(world, x, y, z)) {
 			world.setBlockWithNotify(x, y, z, getBurnResultId(world, x, y, z));
 		} else {
-			world.scheduleBlockUpdate(x, y, z, id, tickDelay());
+			world.scheduleBlockUpdate(x, y, z, block.id(), tickDelay());
 		}
 	}
 	public void ignite(final World world, final int x, final int y, final int z) {
@@ -311,16 +309,16 @@ public class BlockFire extends Block {
 			hasCreatedFire = this.tryIgnite(world, x, y - 1, z);
 		}
 		if (!hasCreatedFire) {
-			world.setBlock(x, y, z, Blocks.FIRE.id);
+			world.setBlock(x, y, z, Blocks.FIRE.id());
 		}
 	}
 	private boolean tryIgnite(final World world, final int x, final int y, final int z) {
 		final int tile = world.getBlockId(x, y, z);
-		if (tile == Blocks.FIRE.id) {
+		if (tile == Blocks.FIRE.id()) {
 			return true;
 		}
 		if (tile == 0) {
-			world.setBlock(x, y, z, Blocks.FIRE.id);
+			world.setBlock(x, y, z, Blocks.FIRE.id());
 			return true;
 		}
 		return false;
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockFlag.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicFlag.java
similarity index 83%
rename from game/core/src/main/java/net/minecraft/core/block/BlockFlag.java
rename to game/core/src/main/java/net/minecraft/core/block/BlockLogicFlag.java
index 92c2be5e1..a6c5498cd 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockFlag.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicFlag.java
@@ -14,13 +14,14 @@ import net.minecraft.core.util.phys.AABB;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.WorldSource;
 
-public class BlockFlag extends BlockTileEntity {
+public class BlockLogicFlag extends BlockLogic {
 
-    public BlockFlag(String key, String namespaceId, int id, Material material) {
-        super(key, namespaceId, id, material);
+    public BlockLogicFlag(Block<?> block, Material material) {
+        super(block, material);
         float f = 2 / 16f;
         float f1 = 1.0F;
         setBlockBounds(0.5F - f, 0.0F, 0.5F - f, 0.5F + f, f1, 0.5F + f);
+        block.withEntity(TileEntityFlag::new);
     }
 
     @Override
@@ -74,16 +75,4 @@ public class BlockFlag extends BlockTileEntity {
     public int getPistonPushReaction(World world, int x, int y, int z) {
         return Material.PISTON_DESTROY_ON_PUSH;
     }
-
-    @Override
-    protected TileEntity getNewBlockEntity() {
-        try
-        {
-            return new TileEntityFlag();
-        }
-        catch(Exception exception)
-        {
-            throw new RuntimeException(exception);
-        }
-    }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockFlower.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicFlower.java
similarity index 92%
rename from game/core/src/main/java/net/minecraft/core/block/BlockFlower.java
rename to game/core/src/main/java/net/minecraft/core/block/BlockLogicFlower.java
index 8aff9ab5d..b50711c11 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockFlower.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicFlower.java
@@ -15,25 +15,25 @@ import org.jetbrains.annotations.Nullable;
 
 import java.util.Random;
 
-public class BlockFlower extends Block implements IBonemealable {
+public class BlockLogicFlower extends BlockLogic implements IBonemealable {
     public static final int MASK_PERMANENT = 0b1000_0000;
 
     public boolean killedByWeather = false;
     public boolean canBeBonemealed = false;
 
-    public BlockFlower(String key, String namespaceId, int id) {
-        super(key, namespaceId, id, Material.plant);
-        setTicking(true);
+    public BlockLogicFlower(Block<?> block) {
+        super(block, Material.plant);
+        block.setTicking(true);
         float f = 0.2F;
         setBlockBounds(0.5F - f, 0.0F, 0.5F - f, 0.5F + f, f * 3F, 0.5F + f);
     }
 
-    public BlockFlower setKilledByWeather() {
+    public BlockLogicFlower setKilledByWeather() {
         killedByWeather = true;
         return this;
     }
 
-    public BlockFlower setBonemealable() {
+    public BlockLogicFlower setBonemealable() {
         canBeBonemealed = true;
         return this;
     }
@@ -129,7 +129,7 @@ public class BlockFlower extends Block implements IBonemealable {
                     continue;
                 }
                 if (rand.nextFloat() > 0.75) {
-                    world.setBlockWithNotify(k1, l1, i2, id);
+                    world.setBlockWithNotify(k1, l1, i2, block.id());
                 }
             }
             return true;
